<script lang="ts">
	import { auth, db } from '$lib/firebase/firebase';
	import { deleteDoc, doc, collection, getDocs, addDoc, setDoc } from 'firebase/firestore';
	import { onMount } from 'svelte';
	import Button from '../../../../../components/Button.svelte';
	import type { Marche, Place } from '../type';
	import AddMarcheForm from './AddMarcheForm.svelte';
	import { Edit2Icon, Trash2Icon } from 'svelte-feather-icons';

	let marches: Place[] = [];

	let isEdit: boolean = false;
	let selectedMarche: Place;

	const getPlacees = async () => {
		marches = [];
		const docRef = await getDocs(collection(db, 'places'));
		docRef.forEach((doc) => {
			marches.push({ ...doc.data(), id: doc.id } as Place);
		});
		marches = marches;
	};

	const deleteOneHoraire = async (id: string) => {
		await deleteDoc(doc(db, 'places', id));
		await getPlacees();
	};

	const putPlacees = async (e: any) => {
		const docRef = collection(db, 'places');
		await addDoc(docRef, e.detail.newMarche);
		await getPlacees();
		openForm = false;
	};

	const editPlaces = async (e: any) => {
		const docRef = doc(db, 'places', e.detail.id);
		await setDoc(docRef, e.detail.newMarche, { merge: true });
		await getPlacees();
		openForm = false;
	};

	onMount(() => {
		getPlacees();
	});

	let openForm: boolean = false;
</script>

<div class="flex flex-col gap-4 items-center justify-center text-center w-1/2">
	<h1>Présences</h1>
	<div class="flex flex-col gap-2 w-full items-center">
		<div class="w-full">
			<Button
				on:click={() => {
					isEdit = false;
					openForm = !openForm;
				}}
			>
				{openForm ? 'Fermer' : 'Ajouter une présence'}
			</Button>
		</div>
		{#if openForm}
			<AddMarcheForm on:add={putPlacees} on:edit={editPlaces} {isEdit} marche={selectedMarche} />
		{/if}
	</div>
	<div class="w-fit">
		{#each marches as marche, index}
			<div class="flex gap-2 items-center justify-between p-2">
				<span class="text-left">{marche.text}</span>

				<Button
					on:click={() => {
						isEdit = true;
						selectedMarche = marche;
						openForm = !openForm;
					}}
				>
					<Edit2Icon />
				</Button>
				<Button on:dblclick={() => marche.id && deleteOneHoraire(marche.id)} type="error">
					<Trash2Icon />
				</Button>
			</div>
			{#if index < marches.length - 1}
				<div class="border-b border-primary-500 w-full" />
			{/if}
		{/each}
	</div>
</div>
